﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;
using System.Text;
using System.IO;

/// <summary>
/// 访问指定URL的页面数据
/// </summary>
public class HttpGet
{
    /// <summary>
    /// 发送页面请求获取指定页面信息
    /// </summary>
    /// <param name="url"></param>
    /// <param name="encode"></param>
    /// <returns></returns>
    public static string PageGet(string url, Dictionary<string, string> h = null, string type = "application/Json", string encode = "utf-8")
    {
        string Result = "";
        if (h != null)
        {
            foreach (var item in h)
            {
                url += (url.IndexOf("?") > -1 ? "&" : "?");
                url += item.Key + "=" + item.Value;
            }
        }

        HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
        //做请求
        request.ContentType = type;
        request.Credentials = CredentialCache.DefaultCredentials;
        HttpWebResponse response = (HttpWebResponse)request.GetResponse();
        //读结果
        Stream receiveStream = response.GetResponseStream();
        StreamReader readStream = new StreamReader(receiveStream, Encoding.GetEncoding(encode));
        Result = readStream.ReadToEnd();
        response.Close();
        readStream.Dispose();
        return Result;
    }

    /// <summary>
    /// 通过Post提交数据
    /// </summary>
    /// <param name="pastUrl"></param>
    /// <param name="postDataStr"></param>
    /// <returns></returns>
    public static string HttpPost(string pastUrl, string postDataStr)
    {
        Stream outstream = null;
        Stream instream = null;
        StreamReader sr = null;
        HttpWebResponse response = null;
        HttpWebRequest request = null;
        Encoding encoding = System.Text.Encoding.GetEncoding("utf-8");
        byte[] data = encoding.GetBytes(postDataStr);
        // 准备请求...
        try
        {
            // 设置参数
            request = WebRequest.Create(pastUrl) as HttpWebRequest;
            CookieContainer cookieContainer = new CookieContainer();
            request.CookieContainer = cookieContainer;
            request.AllowAutoRedirect = true;
            request.Method = "POST";
            request.ContentType = "application/x-www-form-urlencoded";
            request.ContentLength = data.Length;
            outstream = request.GetRequestStream();
            outstream.Write(data, 0, data.Length);
            outstream.Close();
            //发送请求并获取相应回应数据
            response = request.GetResponse() as HttpWebResponse;
            //直到request.GetResponse()程序才开始向目标网页发送Post请求
            instream = response.GetResponseStream();
            sr = new StreamReader(instream, encoding);
            //返回结果网页（html）代码
            string content = sr.ReadToEnd();
            string err = string.Empty;
            return content;
        }
        catch (Exception ex)
        {
            string err = ex.Message;
            return string.Empty;
        }
    }

}
