﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Reflection;
using System.Data;
using System.Data.SqlClient;
using System.Web;

public class Log
{

    #region 写错误记录  ErrorLog()
    /// <summary>
    /// 写错误记录  ErrorLog()
    /// </summary>
    /// <param name="ex"></param>
    /// <returns></returns>
    public static void ErrorLog(Exception ex, string sql)
    {
        string dir = Path() + @"/App_Data/Log/" + DateTime.Now.ToString("yyyy-MM") + "/";
        string fileName = "error_" + DateTime.Now.ToString("dd") + ".txt";
        string path = dir + fileName;
        StreamWriter sw = null;
        try
        {
            Directory.CreateDirectory(dir);
            sw = new StreamWriter(path, true);
            sw.WriteLine(DateTime.Now.ToString("HH:mm:ss") + "----------------------------------");
            sw.WriteLine(sql);
            sw.WriteLine(ex.ToString());
            sw.WriteLine();
            sw.Flush();
        }
        catch { }
        finally
        {
            if (sw != null)
            {
                sw.Close();
                sw = null;
            }
        }
    } 
    #endregion

    #region  写错误记录  ErrorLog()
    /// <summary>
    /// 写错误记录  ErrorLog()
    /// </summary>
    /// <param name="ex"></param>
    /// <returns></returns>
    public static void ErrorLog(Exception ex, SqlCommand cmd)
    {
        string dir = Path() + @"/App_Data/Log/" + DateTime.Now.ToString("yyyy-MM") + "/";
        string fileName = "error_sql_" + DateTime.Now.ToString("dd") + ".txt";
        string path = dir + fileName;
        StreamWriter sw = null;
        try
        {
            Directory.CreateDirectory(dir);
            sw = new StreamWriter(path, true);
            sw.WriteLine(DateTime.Now.ToString("HH:mm:ss") + "----------------------------------");
            sw.WriteLine(ex.ToString());
            sw.WriteLine(cmd.CommandText);
            if (cmd.Parameters != null)
            {
                foreach (SqlParameter par in cmd.Parameters)
                {
                    sw.WriteLine(par.ParameterName + ":" + par.Value.ToString());
                }
            }
            sw.WriteLine();
            sw.Flush();
        }
        catch { }
        finally
        {
            if (sw != null)
            {
                sw.Close();
                sw = null;
            }
        }
    } 
    #endregion

    #region 写错误记录  ErrorLog()
    /// <summary>
    /// 写错误记录  ErrorLog()
    /// </summary>
    /// <param name="ex"></param>
    /// <returns></returns>
    public static void ErrorLog(params SqlParameter[] pars)
    {
        string dir = Path() + @"/App_Data/Log/" + DateTime.Now.ToString("yyyy-MM") + "/";
        string fileName = "log_" + DateTime.Now.ToString("dd") + ".txt";
        string path = dir + fileName;
        StreamWriter sw = null;
        try
        {
            Directory.CreateDirectory(dir);
            sw = new StreamWriter(path, true);
            sw.WriteLine(DateTime.Now.ToString("HH:mm:ss") + "----------------------------------");
            if (pars != null)
            {
                foreach (SqlParameter par in pars)
                {
                    sw.WriteLine(par.ParameterName + ":" + par.Value.ToString());
                }
            }
            sw.WriteLine();
            sw.Flush();
        }
        catch { }
        finally
        {
            if (sw != null)
            {
                sw.Close();
                sw = null;
            }
        }
    } 
    #endregion

    #region 写错误记录  ErrorLog()
    /// <summary>
    /// 写错误记录  ErrorLog()
    /// </summary>
    /// <param name="ex"></param>
    /// <returns></returns>
    public static void ErrorLog(Exception ex)
    {
        string dir = Path() + @"/App_Data/Log/" + DateTime.Now.ToString("yyyy-MM") + "/";
        string fileName = "FuctionError_" + DateTime.Now.ToString("dd") + ".txt";
        string path = dir + fileName;
        StreamWriter sw = null;
        try
        {
            Directory.CreateDirectory(dir);
            sw = new StreamWriter(path, true);
            sw.WriteLine(DateTime.Now.ToString("HH:mm:ss") + "----------------------------------");
            sw.WriteLine(ex.ToString());
            sw.WriteLine();
            sw.Flush();
        }
        catch { }
        finally
        {
            if (sw != null)
            {
                sw.Close();
                sw = null;
            }
        }
    } 
    #endregion

    #region 写错误记录  ErrorLog()
    /// <summary>
    /// 写错误记录  ErrorLog()
    /// </summary>
    /// <param name="ex"></param>
    /// <returns></returns>
    public static void ErrorLog(string str)
    {
        string dir = Path() + @"/App_Data/Log/" + DateTime.Now.ToString("yyyy-MM") + "/";
        string fileName = "log_" + DateTime.Now.ToString("dd") + ".txt";
        string path = dir + fileName;
        StreamWriter sw = null;
        try
        {
            Directory.CreateDirectory(dir);
            sw = new StreamWriter(path, true);
            sw.WriteLine(DateTime.Now.ToString("HH:mm:ss") + "----------------------------------");
            sw.WriteLine(str);
            sw.WriteLine();
            sw.Flush();
        }
        catch { }
        finally
        {
            if (sw != null)
            {
                sw.Close();
                sw = null;
            }
        }
    } 
    #endregion

    #region 写记录  ErrorLog()
    /// <summary> 
    /// 写记录  ErrorLog()
    /// </summary>
    /// <param name="obj"></param>
    public static void ErrorLog(object obj)
    {
        if (obj == null) return;

        string line = "\r\n";
        StringBuilder sb = new StringBuilder();
        Type t = obj.GetType();
        FieldInfo[] fs = t.GetFields(System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Public | BindingFlags.Instance);
        sb.Append("Type:" + t.Name + line);
        foreach (FieldInfo f in fs)
        {
            sb.Append(f.Name);
            sb.Append(":");
            object oF = f.GetValue(obj);
            if (oF != null)
            {
                sb.Append(oF.ToString());
            }
            sb.Append(line);
        }
        ErrorLog(sb.ToString());
    } 
    #endregion

    #region 写错误记录  ErrorLog()
    /// <summary>
    /// 记录此方法出错时的详细记录日志信息


    /// </summary>
    /// <param name="msg">方法的功能</param>
    /// <param name="file_Name">当前文件的名称</param>
    /// <param name="methodName">当前方法的名称</param>
    /// <param name="errorMsg">出错的异常信息</param>
    public static void ErrorLog(string msg, string file_Name, string methodName, string errorMsg)
    {
        ErrorLog(msg + "出错：文件名：" + file_Name + "\t" + "方法名称：" + methodName + "\t出错原因:" + errorMsg);
    }
    #endregion

    #region 拿到项目所在目录  Path()
    /// <summary>
    /// 拿到项目所在目录  Path()
    /// </summary>
    /// <returns></returns>
    private static string Path()
    {
        string path = HttpContext.Current.Server.MapPath("~/");
        return path;
    } 
    #endregion
}
