﻿<%@ WebHandler Language="C#" Class="WXAPI" %>

using System;
using System.Web;
using System.Net;
using System.IO;
using System.Collections.Generic;
using System.Web.SessionState;
using System.Runtime.Serialization.Json;
using System.Text;
using System.Xml;
using System.Collections;
using Newtonsoft.Json;
using WeiXinPay;
using System.Configuration;

public class WXAPI : IHttpHandler, IRequiresSessionState
{
    /// <summary>
    /// 微信API接口文件 将微信里地址指到该文件即可 周祥 2015年10月15日 09:07:02
    /// </summary>
    /// <param name="context"></param>
    public HttpRequest Request = null;
    public HttpResponse Response = null;
    public System.Web.Caching.Cache Cache = null;
    public void ProcessRequest(HttpContext context)
    {
        Cache = context.Cache;
        context.Response.ContentType = "application/Json";
        Request = context.Request;
        Response = context.Response;
        if (Request.HttpMethod.ToString().ToLower() == "post")
        {
            StreamReader stream = new StreamReader(Request.InputStream);
            string xml = stream.ReadToEnd();
            manageXml(xml);
        }
        else
        {
            if (Request["signature"] != null && Request["signature"] != "" && Request["timestamp"] != null && Request["timestamp"] != "" && Request["nonce"] != null && Request["nonce"] != "")
            {
                OneData();
            }
            else
            {
                Response.Write("404");
            }
        }
    }
    /// <summary>
    /// 关注后 推送菜单
    /// </summary>
    /// <returns></returns>
    public string Menu()
    {
        string Content = "";
        Content += "亲爱的车主，感谢您关注“车e泊”，车e泊将为您提供便捷的城市停车服务!\n1.如果您还不是车e泊会员，马上<a href=\"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + WxConfig.appid + "&redirect_uri=http://" + Request.Url.Host + "/ashx/WXURL.ashx?tid=2&response_type=code&scope=snsapi_userinfo&state=s1#wechat_redirect\">注册</a>，成为车易泊会员，享受便捷停车。\n2.已是车易泊会员，马上<a href=\"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + WxConfig.appid + "&redirect_uri=http://" + Request.Url.Host + "/ashx/WXURL.ashx?tid=1&response_type=code&scope=snsapi_userinfo&state=s1#wechat_redirect\">登陆</a>，享受会员服务。";
        return Content;
    }
    /// <summary>
    /// 返回XML给微信
    /// </summary>
    /// <param name="FromUserName"></param>
    /// <param name="ToUserName"></param>
    /// <param name="msg"></param>
    public void ReturnXml(string FromUserName, string ToUserName, string msg)
    {
        string strresponse = "<xml>";
        strresponse += "<ToUserName><![CDATA[" + FromUserName + "]]></ToUserName>";
        strresponse += "<FromUserName><![CDATA[" + ToUserName + "]]></FromUserName>";
        strresponse += "<CreateTime>" + DateTime.Now.Ticks.ToString() + "</CreateTime>";
        strresponse += "<MsgType><![CDATA[text]]></MsgType>";
        strresponse += "<Content><![CDATA[" + msg + "]]></Content>";
        strresponse += "<FuncFlag>0<FuncFlag>";
        strresponse += "</xml>";
        Response.Write(strresponse);
    }
    /// <summary>
    /// 返回图文消息
    /// </summary>
    /// <param name="FromUserName"></param>
    /// <param name="ToUserName"></param>
    /// <param name="list"></param>
    /// <param name="flag"></param>
    public void ReturnImgXml(string FromUserName, string ToUserName, IList<ReturnPicModel> list, int flag = 0)
    {
        string strresponse = "<xml>";
        strresponse += "<ToUserName><![CDATA[" + FromUserName + "]]></ToUserName>";
        strresponse += "<FromUserName><![CDATA[" + ToUserName + "]]></FromUserName>";
        strresponse += "<CreateTime>" + DateTime.Now.Ticks.ToString() + "</CreateTime>";
        strresponse += "<MsgType><![CDATA[news]]></MsgType>";
        strresponse += "<ArticleCount>1</ArticleCount>";
        strresponse += "<Articles>";
        for (int i = 0; i < list.Count; i++)
        {
            var m = list[i];
            strresponse += "<item>";
            strresponse += "<Title><![CDATA[" + m.Title + "]]></Title>";
            strresponse += "<Description><![CDATA[" + m.Description + "]]></Description>";
            strresponse += "<PicUrl><![CDATA[" + m.PicUrl + "]]></PicUrl>";
            strresponse += "<Url><![CDATA[" + m.Url + "]]></Url>";
            strresponse += "</item>";
        }
        strresponse += "</Articles>";
        strresponse += "<FuncFlag>" + flag + "</FuncFlag>";
        strresponse += "</xml>";
        Response.Write(strresponse);
    }
    /// <summary>
    /// 返回文本消息
    /// </summary>
    /// <param name="FromUserName"></param>
    /// <param name="msg"></param>
    public void ReturnTxt(string FromUserName, string msg)
    {
        object obj = new
        {
            touser = FromUserName,
            msgtype = "text",
            text = new
            {
                content = msg
            }
        };
        string strresponse2 = JsonConvert.SerializeObject(obj);
        string token = HttpGet.HttpPost("https://api.weixin.qq.com/cgi-bin/message/custom/send?access_token=" + GetAccessToken(), strresponse2);

    }
    /// <summary>
    /// 转接客服系统
    /// </summary>
    /// <param name="FromUserName"></param>
    /// <param name="ToUserName"></param>
    /// <param name="msg"></param>
    public void ReturnKf(string FromUserName, string ToUserName)
    {
        string strresponse2 = "{ \"touser\":\"" + FromUserName + "\",\"msgtype\":\"text\",\"text\":{\"content\":\"正在接入客服,请稍候!\" }}";
        string token = HttpGet.HttpPost("https://api.weixin.qq.com/cgi-bin/message/custom/send?access_token=" + GetAccessToken(), strresponse2);
        string strresponse = "<xml>";
        strresponse += "<ToUserName><![CDATA[" + FromUserName + "]]></ToUserName>";
        strresponse += "<FromUserName><![CDATA[" + ToUserName + "]]></FromUserName>";
        strresponse += "<CreateTime>" + DateTime.Now.Ticks.ToString() + "</CreateTime>";
        strresponse += "<MsgType><![CDATA[transfer_customer_service]]></MsgType>";
        strresponse += "</xml>";
        Response.Write(strresponse);

    }
    /// <summary>
    /// 处理微信推送过来的消息
    /// </summary>
    /// <param name="xml"></param>
    public void manageXml(string xml)
    {
        try
        {
            //解析    
            Hashtable requestHT = ParseXml(xml);
            //消息发送者   
            string fromUserName = (string)requestHT["FromUserName"];
            //公众帐号    
            string toUserName = (string)requestHT["ToUserName"];
            //消息类型    
            string msgType = (string)requestHT["MsgType"];
            //消息处理
            if (msgType == ReqMsgType.Text.ToString())
            {
                //文本消息 可以用来自动获取用户输入的关键词 进行推送
                string msg = (string)requestHT["Content"];

                ReturnTxt(fromUserName, "爷忙着呢,别吵!");
            }
            else if (msgType == ReqMsgType.Event)
            {
                //事件消息 监控各个事件
                //事件类型    
                string eventType = (string)requestHT["Event"];
                if (eventType == ReqEventType.CLICK)
                {
                    //菜单点击
                    string eventEventKey = (string)requestHT["EventKey"];
                    switch (eventEventKey)
                    {
                        default:
                            break;
                    }
                }
                else if (eventType == ReqEventType.Subscribe)
                {
                    //关注用户
                    ReturnXml(fromUserName, toUserName, Menu());
                }
                else if (eventType == ReqEventType.Unsubscribe)
                {
                    //取消关注 暂时不做处理
                }
                else if (eventType == ReqEventType.VIEW)
                {
                    //菜单跳转 暂时不做处理

                }
            }
            else if (msgType == ReqMsgType.Image)
            {
                //图片消息处理
            }
            else if (msgType == ReqMsgType.Link)
            {
                //链接消息处理
            }
            else if (msgType == ReqMsgType.Location)
            {

                //位置消息处理
            }
            else if (msgType == ReqMsgType.Video)
            {
                //视频消息处理
            }
            else if (msgType == ReqMsgType.Voice)
            {
                //语音消息处理
            }
        }
        catch (Exception ex)
        {
            Log.ErrorLog("处理微信发来的请求信息出错:" + ex.ToString());
        }
    }
    /// <summary>
    /// 创建菜单
    /// </summary>
    public void CreateOrDelMenu(bool IsDel)
    {
        string menu = "{"
      + "\"button\": ["
        + "  {"
         + "\"type\": \"view\", "
             + "\"name\": \"云锁车\", "
             + "  \"url\": \"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + WxConfig.appid + "&redirect_uri=http://" + Request.Url.Host + "/ashx/WXURL.ashx?tid=3&response_type=code&scope=snsapi_userinfo&state=s1#wechat_redirect\", "
              + "\"sub_button\": [ ]"
       + "   }, "
    + "  {"
             + "\"type\": \"view\", "
             + "\"name\": \"缴停车费\", "
             + "  \"url\": \"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + WxConfig.appid + "&redirect_uri=http://" + Request.Url.Host + "/ashx/WXURL.ashx?tid=4&response_type=code&scope=snsapi_userinfo&state=s1#wechat_redirect\", "
             + " \"sub_button\": [ ]"
          + "},"
         + " {"
           + "   \"name\": \"会员中心\", "
            + "  \"sub_button\": ["
             + "   {"
                  + " \"type\": \"view\", "
                  + "  \"name\": \"我的钱包\", "
                 + "   \"url\": \"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + WxConfig.appid + "&redirect_uri=http://" + Request.Url.Host + "/ashx/WXURL.ashx?tid=5&response_type=code&scope=snsapi_userinfo&state=s1#wechat_redirect\", "
                  + "   \"sub_button\": [ ]"
               + "  }, "
             + " {"
                  + "\"type\": \"view\", "
                + "  \"name\": \"交易查询\","
               + "   \"url\": \"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + WxConfig.appid + "&redirect_uri=http://" + Request.Url.Host + "/ashx/WXURL.ashx?tid=6&response_type=code&scope=snsapi_userinfo&state=s1#wechat_redirect\", "
                + "  \"sub_button\": [ ]"
            + "  }, "
              + " {"
                  + "\"type\": \"view\", "
                + "  \"name\": \"解锁设置\","
               + "   \"url\": \"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + WxConfig.appid + "&redirect_uri=http://" + Request.Url.Host + "/ashx/WXURL.ashx?tid=7&response_type=code&scope=snsapi_userinfo&state=s1#wechat_redirect\", "
                + "  \"sub_button\": [ ]"
            + "  } "
            + "  ]"
        + "  }"
      + "]"
+ " }";
        if (IsDel)
        {
            HttpGet.HttpPost(" https://api.weixin.qq.com/cgi-bin/menu/create?access_token=" + GetAccessToken(), menu);
        }
        else
        {
            HttpGet.HttpPost(" https://api.weixin.qq.com/cgi-bin/menu/delete?access_token=" + GetAccessToken(), menu);
        }
    }
    /// <summary>
    /// 将xml文件转换成Hashtable
    /// </summary>
    /// <param name="xml"></param>
    /// <returns></returns>
    public static Hashtable ParseXml(String xml)
    {
        XmlDocument xmlDocument = new XmlDocument();
        xmlDocument.LoadXml(xml);
        XmlNode bodyNode = xmlDocument.ChildNodes[0];
        Hashtable ht = new Hashtable();
        if (bodyNode.ChildNodes.Count > 0)
        {
            foreach (XmlNode xn in bodyNode.ChildNodes)
            {
                ht.Add(xn.Name, xn.InnerText);
            }
        }
        return ht;
    }
    /// <summary>
    /// 获取授权 注意:授权一般有效期为2小时 所以需要进行存储 否则导致接口调用失败
    /// </summary>
    /// <returns></returns>
    public string GetAccessToken()
    {
        if (Cache["WxAccessToken"] == null)
        {
            Dictionary<string, string> h = new Dictionary<string, string>();
            h.Add("grant_type", "client_credential");
            h.Add("appid", WxConfig.appid);
            h.Add("secret", WxConfig.appsecret);
            string token = HttpGet.PageGet("https://api.weixin.qq.com/cgi-bin/token", h);
            TokenModel model = null;
            try
            {
                model = JsonConvert.DeserializeObject<TokenModel>(token);
            }
            catch (Exception ex)
            {
                Log.ErrorLog("微信接口获取AccessToken出错:" + ex.ToString());
            }
            if (model.access_token != null)
            {
                Cache.Insert("WxAccessToken", model.access_token, null, DateTime.Now.AddSeconds(model.expires_in), System.Web.Caching.Cache.NoSlidingExpiration);
                return model.access_token;
            }
        }
        return (String)Cache["WxAccessToken"];
    }
    /// <summary>
    /// 第一次绑定 验证 及创建菜单
    /// </summary>
    public void OneData()
    {
        string echoStr = Request.QueryString["echoStr"].ToString();
        if (checkSignature())
        {
            CreateOrDelMenu(false);
            CreateOrDelMenu(true);
            if (!string.IsNullOrEmpty(echoStr))
            {
                Response.Write(echoStr);
                Response.End();
            }

        }
    }
    /// <summary>
    /// 验证微信签名
    /// </summary>
    /// <returns></returns>
    public bool checkSignature()
    {
        string signature = Request["signature"];
        string timestamp = Request["timestamp"];
        string nonce = Request["nonce"];
        string token = ConfigurationManager.AppSettings["wxKey"];
        string[] ArrTmp = { token, timestamp, nonce };
        Array.Sort(ArrTmp);
        string tmpStr = string.Join("", ArrTmp);
        tmpStr = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(tmpStr, "SHA1");
        tmpStr = tmpStr.ToLower();
        if (tmpStr == signature)
        {
            return true;
        }
        return false;
    }
    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

}
public class TokenModel
{
    /// <summary>
    /// token
    /// </summary>
    public string access_token { get; set; }
    /// <summary>
    /// time
    /// </summary>
    public int expires_in { get; set; }
}
public class TokenOpenModel
{
    public string access_token { get; set; }
    public int expires_in { get; set; }
    public string refresh_token { get; set; }
    public string openid { get; set; }
    public string scope { get; set; }
}
public class ReturnPicModel
{
    public string Title { get; set; }
    public string Description { get; set; }
    public string PicUrl { get; set; }
    public string Url { get; set; }
}
public class ReqMsgType
{
    /// <summary>
    /// 图片消息
    /// </summary>
    public const string Image = "image";
    /// <summary>
    /// 语音消息
    /// </summary>
    public const string Voice = "voice";
    /// <summary>
    /// 视频消息
    /// </summary>
    public const string Video = "video";
    /// <summary>
    /// 文本消息
    /// </summary>
    public const string Text = "text";
    /// <summary>
    /// 事件消息
    /// </summary>
    public const string Event = "event";
    /// <summary>
    /// 位置消息
    /// </summary>
    public const string Location = "location";
    /// <summary>
    /// 链接消息
    /// </summary>
    public const string Link = "link";
}
public class ReqEventType
{
    /// <summary>
    /// 关注消息
    /// </summary>
    public const string Subscribe = "subscribe";
    /// <summary>
    /// 取消关注
    /// </summary>
    public const string Unsubscribe = "unsubscribe";
    /// <summary>
    /// 菜单点击
    /// </summary>
    public const string CLICK = "CLICK";
    /// <summary>
    /// 菜单跳转
    /// </summary>
    public const string VIEW = "VIEW";
}