﻿<%@ WebHandler Language="C#" Class="WXURL" %>

using System;
using System.Web;
using System.Web.SessionState;
using WeiXinPay;

public class WXURL : IHttpHandler, IRequiresSessionState
{
    /// <summary>
    /// 微信URL统一处理 周祥 2015年10月20日  方便公共获取用户OPENID
    /// </summary>
    /// <param name="context"></param>
    public void ProcessRequest(HttpContext context)
    {
        Log.ErrorLog("code:" + context.Request["code"]);
        if (context.Request["code"] == null || context.Request["code"] == "")
        {
            context.Response.Redirect("https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + WxConfig.appid + "&redirect_uri=http://" + context.Request.Url.Host + "/ashx/WXURL.ashx?tid=" + context.Request["tid"] + " &response_type=code&scope=snsapi_userinfo&state=s1&connect_redirect=1#wechat_redirect");
        }

        var wx = new WeiXinCommon();
        //获取微信授权 
        WxModelAccessToken wx_token = wx.GetAccessToken(context.Request["code"]);
        //缓存当前OPENID 转向指定页面
        context.Session["user_openid"] = wx_token.openid;
        switch (Convert.ToInt32(context.Request["tid"]))
        {
            case 1:
                context.Response.Redirect("http://" + context.Request.Url.Host + "/#/login");
                break;
            case 2:
                context.Response.Redirect("http://" + context.Request.Url.Host + "/#/register");
                break;
            case 3:
                context.Response.Redirect("http://" + context.Request.Url.Host + "/#/yuncar");
                break;
            case 4:
                context.Response.Redirect("http://" + context.Request.Url.Host + "/#/paysuan");
                break;
            case 5:
                context.Response.Redirect("http://" + context.Request.Url.Host + "/#/myaccount");
                break;
            case 6:
                context.Response.Redirect("http://" + context.Request.Url.Host + "/#/paysearch");
                break;
            case 7:
                context.Response.Redirect("http://" + context.Request.Url.Host + "/#/lock");
                break;
        }
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

}